ru.bitel.bgbilling.kernel.directory.api.common.bean

## Interface Directory<K extends Id>

- Type Parameters:
    `K` -
  All Known Implementing Classes:
    AreaDao, ChargeTypeDao, CityDao, ContractGroupDao, ContractObjectParamDao, ContractObjectTypeDao, CostMapManager, CountryDao, DeviceGroupDao, DeviceTypeDao, DocumentJournalDao, DocumentStatusDao, DocumentTypeDao, DomainDao, EntitySpecAttrDao, EntitySpecAttrListItemDao, EntitySpecDao, GroupRightDao, InetDeviceTypeDao, InetOptionDao, InetServTypeDao, PaymentTypeDao, ProductSpecDao, QuarterDao, RangeMapDao, ReserveTypeDao, ServiceDao, ServiceManager, ServiceSpecDao, SmartHousePackageBaseDao, StreetDao, SubscriptionModeDao, SubscriptionTypeDao, SubscriptionTypeDao, TariffGroupDao, TariffGroupManager, TariffPlanDao, TariffPlanManager, TrafficRangeSpecDao, TrafficTypeDao, TrafficTypeLinkDao, TvAccountSpecDao, TvChannelSpecDao, TvDeviceTypeDao, UserInfoDao, VoiceAccountTypeAbstractDao, VoiceAccountTypeDao, VoiceDeviceTypeDao, VoiceOperAccountTypeDao, VoiceOptionDao, VoiceZoneDao

      public interface Directory<K extends Id>

  "Справочник" для бинов, которые изменяются редко, но используются в нескольких местах другими бинами.
  Например, "тип" чего-то.
  Такой бин должен быть аннотирован `DirectoryItem`.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `delete(int id)` Удаление элемента по id
    `K` | `get(int id)` Получение элемента по id
    `K` | `get(java.lang.String title)` Получение элемента по title(name) Может быть не имплементировано - в этом случае бросается `UnsupportedOperationException`
    `java.util.List<K>` | `list()` Получение всего списка элементов из справочника
    `void` | `update(K k)` Изменение/добавление элемента справочника

- - ### Method Detail

    - #### get

          K get(int id)
          throws ru.bitel.bgbilling.common.BGException

      Получение элемента по id
      Parameters:
        `id` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### get

          K get(java.lang.String title)
          throws ru.bitel.bgbilling.common.BGException

      Получение элемента по title(name) Может быть не имплементировано - в этом случае бросается `UnsupportedOperationException`
      Parameters:
        `title` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### list

          java.util.List<K> list()
                          throws ru.bitel.bgbilling.common.BGException

      Получение всего списка элементов из справочника
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### update

          void update(K k)
               throws ru.bitel.bgbilling.common.BGException

      Изменение/добавление элемента справочника
      Parameters:
        `k` -
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### delete

          int delete(int id)
              throws ru.bitel.bgbilling.common.BGException

      Удаление элемента по id
      Parameters:
        `id` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`